searchNodes=[{"doc":"Prompt provides a complete solution for building interactive command line applications.It's very flexible and can be used just to provide helpers for taking input from the user and displaying output.Basic Usageimport Prompt includes utilities for:printing to the screen -&gt; display/1printing tables to the screen -&gt; table/1asking for confirmation -&gt; confirm/1picking from a list of choices -&gt; select/1asking for passwords -&gt; password/1free form text -&gt; text/1Advanced usageTo build a more advanced terminal application including sub-commands, define a module and use Prompt, otp_app: :your_app then build a keyword list of Prompt.Command that represents your commands and arguments and pass them to process/2.Doing this will give you the following options out of the box:--version will pull your app version from mix.exs--help will print your @moduledoc for help.Exampledefmodule MyApp.CLI do @moduledoc &quot;This will print when a user types `myapp --help` in the commandline&quot; use Prompt, otp_app: :my_app # the entry point to your app, takes the command line args def main(argv), do: argv |&gt; process(first: MyApp.CLI.FirstCommand) end end # a command defmodule MyApp.CLI.FirstCommand do @moduledoc &quot;This prints when the help() command is called&quot; use Prompt.Command @impl true def init(argv) do argv |&gt; OptionParser.parse( strict: [help: :boolean, switch1: :boolean, swtich2: :boolean], aliases: [h: :help] ) |&gt; parse() #whatever you return from init will be what is passed to `process/1` end @impl true def process(%{help: true}, do: help() def process(%{switch1: switch1, switch2: switch2} do # do something based on the command and switches display(&quot;command output&quot;) end defp parse({[help: true], _, _}, do: %{help: true} defp parse({opts, _, _}) do switch1 = Keyword.get(opts, :switch1, false) switch2 = Keyword.get(opts, :switch2, false) %{help: false, switch1: switch1, switch2: switch2} end endThe key in the Keyword list that you pass to process/2 is what you expect the user to use as a command, the value is the Prompt.Command module that will process the command.Once built, your command will be able to take a first subcommand.&gt;&gt;&gt; my_app first --switch1 command output ... &gt;&gt;&gt; my_app --version 0.0.1By default we try to display the @moduledoc when there is an error or when --help is passed in. This is overrideable though by implementing your own version of help/0.Building for DistributionThere are a couple of different options for building a binary ready for distributing. Which ever approach you decide to use, you'll probably want to keep the docs instead of stripping them. For escripts, you'll add the following to the escript key in mix.exs, if using Bakeware, you'll add it to the releases key.:strip_beams: [keep: [&quot;Docs&quot;]]EscriptAn escript is the most straightforward approach, but requires that erlang is already installed on the system.BakewareThis has been my preferred approach recently. Bakeware uses releases to build a single executable binary that can be run on the system without the dependency on erlang or elixir.For Bakeware, I also set export RELEASE_DISTRIBUTION=none in rel/env.sh.eex and rel/env.bat.eex - unless you need erlang distribution in your CLI.For a complete example see Slim","ref":"Prompt.html","title":"Prompt","type":"behaviour"},{"doc":"Display a choice prompt with custom answers. Takes a keyword list of answers in the form of atom to return and string to display.[yes: &quot;y&quot;, no: &quot;n&quot;]will show &quot;(y/n)&quot; and return :yes or :no based on the choice.Available options:default_answer: the default answer. If default isn't passed, the first is the default.color: A color from the IO.ANSI moduleExamplesiex&gt; Prompt.choice(&quot;Save password?&quot;, ...&gt; [yes: &quot;y&quot;, no: &quot;n&quot;, regenerate: &quot;r&quot;], ...&gt; default_answer: :regenerate ...&gt; ) &quot;Save Password? (y/n/R):&quot; [enter] iex&gt; :regenerate","ref":"Prompt.html#choice/3","title":"Prompt.choice/3","type":"function"},{"doc":"Display a Y/n prompt.Sets 'Y' as the the default answer, allowing the user to just press the enter key. To make 'n' the default answer pass the option default_answer: :noAvailable options:color: A color from the IO.ANSI moduledefault_answer: :yes or :nomask_line: should the line be erased after the confirmExamplesiex&gt; Prompt.confirm(&quot;Send the email?&quot;) &quot;Send the email? (Y/n):&quot; Y iex&gt; :yes iex&gt; Prompt.confirm(&quot;Send the email?&quot;, default_answer: :no) &quot;Send the email? (y/N):&quot; [enter] iex&gt; :no","ref":"Prompt.html#confirm/2","title":"Prompt.confirm/2","type":"function"},{"doc":"Writes text to the screen.Takes a single string argument or a list of strings where each item in the list will be diplayed on a new line.Available options:color: A color from the IO.ANSI moduletrim: true | false --- Defaults to false (will put a at the end of the textposition: :left | :right --- Print the content starting from the leftmost position or the rightmost positionmask_line: true | false --- Prompts the user to press enter and afterwards masks the line just printedthe main use case here is a password that you may want to show the user but hide after the user has a chance to write it down, or copy it.Examplesiex&gt; Prompt.display(&quot;Hello from the terminal!&quot;) &quot;Hello from the terminal!&quot; iex&gt; Prompt.display([&quot;Hello&quot;, &quot;from&quot;, &quot;the&quot;, &quot;terminal&quot;]) &quot;Hello&quot; &quot;from&quot; &quot;the&quot; &quot;terminal&quot;","ref":"Prompt.html#display/2","title":"Prompt.display/2","type":"function"},{"doc":"Prints help to the screen when there is an error, or --help is passed as an argument","ref":"Prompt.html#c:help/0","title":"Prompt.help/0","type":"callback"},{"doc":"Prompt the user for input, but conceal the users typing.Available options:color: A color from the IO.ANSI moduleExamplesiex&gt; Prompt.password(&quot;Enter your passsword&quot;) &quot;Enter your password:&quot; iex&gt; &quot;super_secret_passphrase&quot;","ref":"Prompt.html#password/2","title":"Prompt.password/2","type":"function"},{"doc":"Process the command line arguments based on the defined commands","ref":"Prompt.html#c:process/2","title":"Prompt.process/2","type":"callback"},{"doc":"Displays options to the user denoted by numbers.Allows for a list of 2 tuples where the first value is what is displayed and the second value is what is returned to the caller.Available options:color: A color from the IO.ANSI modulemulti: true | false (default) - allow for the user to select multiple values?Examplesiex&gt; Prompt.select(&quot;Choose One&quot;, [&quot;Choice A&quot;, &quot;Choice B&quot;]) &quot; [1] Choice A&quot; &quot; [2] Choice B&quot; &quot;Choose One [1-2]:&quot; 1 iex&gt; &quot;Choice A&quot; iex&gt; Prompt.select(&quot;Choose One&quot;, [{&quot;Choice A&quot;, 1000}, {&quot;Choice B&quot;, 1001}]) &quot; [1] Choice A&quot; &quot; [2] Choice B&quot; &quot;Choose One [1-2]:&quot; 2 iex&gt; 1001 iex&gt; Prompt.select(&quot;Choose as many as you want&quot;, [&quot;Choice A&quot;, &quot;Choice B&quot;], multi: true) &quot; [1] Choice A&quot; &quot; [2] Choice B&quot; &quot;Choose as many as you want [1-2]:&quot; 1 2 iex&gt; [&quot;Choice A&quot;, &quot;Choice B&quot;]","ref":"Prompt.html#select/3","title":"Prompt.select/3","type":"function"},{"doc":"Print an ASCII table of data. Requires a list of lists as input.Available Optionsheader: true | false (default) --- use the first element as a header of the tableborder: :normal (default) | :markdown --- determine how the border is displayedExamplesiex&gt; Prompt.table([[&quot;Hello&quot;, &quot;from&quot;, &quot;the&quot;, &quot;terminal!&quot;],[&quot;this&quot;, &quot;is&quot;, &quot;another&quot;, &quot;row&quot;]]) &quot; +-------+------+---------+----------+ | Hello | from | the | terminal | | this | is | another | row | +-------+------+---------+----------+ &quot; iex&gt; Prompt.table([[&quot;One&quot;, &quot;Two&quot;, &quot;Three&quot;, &quot;Four&quot;], [&quot;Hello&quot;, &quot;from&quot;, &quot;the&quot;, &quot;terminal!&quot;],[&quot;this&quot;, &quot;is&quot;, &quot;another&quot;, &quot;row&quot;]], header: true) &quot; +-------+------+---------+----------+ | One | Two | Three | Four | +-------+------+---------+----------+ | Hello | from | the | terminal | | this | is | another | row | +-------+------+---------+----------+ &quot; iex&gt; Prompt.table([[&quot;One&quot;, &quot;Two&quot;, &quot;Three&quot;, &quot;Four&quot;], [&quot;Hello&quot;, &quot;from&quot;, &quot;the&quot;, &quot;terminal!&quot;],[&quot;this&quot;, &quot;is&quot;, &quot;another&quot;, &quot;row&quot;]], header: true, border: :markdown) &quot; | One | Two | Three | Four | |-------|------|---------|----------| | Hello | from | the | terminal | | this | is | another | row | &quot;","ref":"Prompt.html#table/2","title":"Prompt.table/2","type":"function"},{"doc":"Use this to get an iolist back of the table. Useful when you want an ascii table/1 for other mediums like markdown files.","ref":"Prompt.html#table_data/2","title":"Prompt.table_data/2","type":"function"},{"doc":"Display text on the screen and wait for the users text imput.Available options:color: A color from the IO.ANSI moduleExamplesiex&gt; Prompt.text(&quot;Enter your email&quot;) &quot;Enter your email:&quot; t@t.com iex&gt; t@t.com","ref":"Prompt.html#text/2","title":"Prompt.text/2","type":"function"},{"doc":"Helps users define and build command line commands.Defines the behaviour for a Command.We expect init/1 to be called with the command line options and get back a data structure that is passed to process/1 which handles all of the side effects of the command itself.Exampledefmodule MyCommand do @moduledoc &quot;MyCommand&#39;s help message help() is defined in the __using__ macro that prints this message if called&quot; use Prompt.Command @impl true def init(_argv) do # parse list of args to map or struct %{list: true, help: false, directory: &quot;path/to/dir&quot;} end @impl true def process(%{help: true}), do: help() # this help function is defined by default in the macro that prints the @moduledoc when called def process(%{list: true, help: false, directory: dir}) do display(File.ls!(dir)) end endTypically one will use the OptionParser.parse/1 function to parse the commanddefp parse(argv) do argv |&gt; OptionParser.parse( strict: [help: :boolean, directory: :string, list: :boolean], aliases: [h: :help, d: :directory] ) |&gt; _parse() end defp _parse({opts, _, _}) do help = Keyword.get(opts, :help, false) dir = Keyword.get(opts, :directory, &quot;./&quot;) list = Keyword.get(opts, :length, true) %{help: help, directory: dir, list: list} endIf this is used in a release, help() won't print the @moduledoc correctly because releases strip documentation by default. For this to work correctly, tell the release to keep docs:releases: [ appname: [ strip_beams: [keep: [&quot;Docs&quot;]] ] ]","ref":"Prompt.Command.html","title":"Prompt.Command","type":"behaviour"},{"doc":"Prints the help available for this command","ref":"Prompt.Command.html#c:help/0","title":"Prompt.Command.help/0","type":"callback"},{"doc":"Takes the options passed in via the command line and tramforms them into a struct that the process command can handle","ref":"Prompt.Command.html#c:init/1","title":"Prompt.Command.init/1","type":"callback"},{"doc":"Processes the command and does the things required","ref":"Prompt.Command.html#c:process/1","title":"Prompt.Command.process/1","type":"callback"},{"doc":"Manipulate the position of the cursor and the display of previous text.","ref":"Prompt.Position.html","title":"Prompt.Position","type":"module"},{"doc":"Clears the content from the previous number of lines and resets the cursor.","ref":"Prompt.Position.html#clear_lines/1","title":"Prompt.Position.clear_lines/1","type":"function"},{"doc":"Mask the content on the terminal relative_line above. By default will clear the line and put ####### in its place then move the cursor back to the current line.","ref":"Prompt.Position.html#mask_line/1","title":"Prompt.Position.mask_line/1","type":"function"},{"doc":"Terminal UI Library for ElixirMotivationInstallationBasic UsageDisplay text on the screenAsk the user for inputAsk the user for a passwordAsk the user for confirmationCustom confirmation choicesList of selectionsTablesAdvanced UsageExample Application","ref":"readme.html","title":"Terminal UI Library for Elixir","type":"extras"},{"doc":"To create a really great development experience and API for Elixir developers that want to build commandline tools.","ref":"readme.html#motivation","title":"Terminal UI Library for Elixir - Motivation","type":"extras"},{"doc":"Add prompt to your list of dependencies in mix.exs:def deps do [ {:prompt, &quot;~&gt; 0.5&quot;} ] endRead the official documentation","ref":"readme.html#installation","title":"Terminal UI Library for Elixir - Installation","type":"extras"},{"doc":"All of the following commands take a keyword list of options for things like text color and positioning.Display text on the screenPrompt.display/2Prompt.display(&quot;Hello, world!&quot;)Ask the user for inputPrompt.text/2 Useful for prompting the user to enter freeform textPrompt.text(&quot;Enter info here&quot;)Will display:&gt; Enter info here:and wait for the user to enter textAsk the user for a passwordPrompt.password/2 When you need to hide the input that the user typesPrompt.password(&quot;Enter password&quot;)Ask the user for confirmationPrompt.confirm/2Prompt.confirm(&quot;Are you sure?&quot;)Will display:&gt; Are you sure? (Y/n):and will allow the user to just press [enter] to confirmIf you'd prefer n to be the default pass the default_answer optionPrompt.confirm(&quot;Are you sure?&quot;, default_answer: :no)Returns :yes or :no based on the answerCustom confirmation choicesPrompt.choice/2 Sometimes yes/no aren't the only choices a user can make, this method allows you to pass any choices as the confirmation.Prompt.choice(&quot;Accept, Reload or Cancel&quot;, accept: &quot;a&quot;, reload: &quot;r&quot;, cancel: &quot;c&quot;)displays&gt; Accept, Reload or Cancel (A/r/c):Returns the key of the answer i.e :accept, :reload or cancel in this exammpleList of selectionsPrompt.select/2 To show the user a list of options to select fromPrompt.select(&quot;Choose a protocol&quot;, [&quot;file://&quot;, &quot;ssh://&quot;, &quot;ftp://&quot;])Displays: [1] file:// [2] ssh:// [3] ftp:// &gt; Choose a protocol [1-3]:and returns a string of their choiceTablesPrompt.table/2 To show a table of dataPrompt.table([[&quot;Hello&quot;, &quot;from&quot;, &quot;the&quot;, &quot;terminal!&quot;],[&quot;this&quot;, &quot;is&quot;, &quot;another&quot;, &quot;row&quot;]])Will display&gt; +-------+------+---------+----------+ | Hello | from | the | terminal | | this | is | another | row | +-------+------+---------+----------+","ref":"readme.html#basic-usage","title":"Terminal UI Library for Elixir - Basic Usage","type":"extras"},{"doc":"To use the more advanced features, see the official documentation","ref":"readme.html#advanced-usage-with-subcommands","title":"Terminal UI Library for Elixir - Advanced Usage with Subcommands","type":"extras"},{"doc":"For a complete example, take a look at Slim - a cherry-picking tool","ref":"readme.html#example","title":"Terminal UI Library for Elixir - Example","type":"extras"},{"doc":"ChangelogAll notable changes to this project will be documented in this file.The format is based on Keep a Changelog, and this project adheres to Semantic Versioning.","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"AddedMany more tests","ref":"changelog.html#unreleased","title":"Changelog - Unreleased","type":"extras"},{"doc":"","ref":"changelog.html#livebook-notebook-with-an-example","title":"Changelog - Livebook notebook with an example","type":"extras"},{"doc":"Addeda help/0 callback and the ability to overrideChangedInstead of taking a list of tuples for commands ([{&quot;command&quot;, Module&quot;}]), now take a Keyword list ([command: Module])","ref":"changelog.html#0-6-0-2021-10-17","title":"Changelog - 0.6.0 - 2021-10-17","type":"extras"}]